regina::NBlockedSFSPair Class Reference
Standard Triangulations and Subcomplexes

Represents a blocked pair of Seifert fibred spaces joined along a single connecting torus. More...

`#include <subcomplex/nblockedsfspair.h>`

Inheritance diagram for regina::NBlockedSFSPair:

## Public Member Functions

| ~NBlockedSFSPair ()
| Destroys this structure and its constituent components. More...
const NSatRegion & | region (int which) const
| Returns details of one of the two bounded saturated regions that form this triangulation. More...
const NMatrix2 & | matchingReln () const
| Returns the matrix describing how the two saturated region boundaries are joined. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Input and Output
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NBlockedSFSPair * | isBlockedSFSPair (NTriangulation *tri)
| Determines if the given triangulation is a blocked pair of Seifert fibred spaces, as described by this class. More...
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Detailed Description

Represents a blocked pair of Seifert fibred spaces joined along a single connecting torus.

This is a particular type of triangulation of a graph manifold, formed from two saturated regions whose torus boundaries are identified. An optional layering may be placed between the two torus boundaries to allow for a more interesting relationship between the boundary curves of each region. For more detail on saturated regions and their constituent saturated blocks, see the NSatRegion class; for more detail on layerings, see the NLayering class.

Each of the two saturated regions must have precisely one boundary component formed from just one saturated annulus, and this boundary may not be twisted (i.e., it must be a torus, not a Klein bottle). The way in which the boundaries from each region are identified is specified by a 2-by-2 matrix M, which expresses curves representing the fibres and base orbifold of the second region in terms of the first (see the page on Notation for Seifert fibred spaces for terminology).

More specifically, suppose that f0 and o0 are directed curves on the first region boundary and f1 and o1 are directed curves on the second region boundary, where f0 and f1 represent the fibres of each region and o0 and o1 represent the base orbifolds. Then the boundaries are joined according to the following relation:

        [f1]       [f0]
        [  ] = M * [  ]
        [o1]       [o0]

If a layering is present between the two boundaries, then the boundary curves are not identified directly. In this case, the matrix M shows how the layering relates the curves on each region boundary.

Note that the routines writeName() and writeTeXName() do not offer enough information to uniquely identify the triangulation, since this essentially requires 2-dimensional assemblings of saturated blocks. For full details, writeTextLong() may be used instead.

The optional NStandardTriangulation routine getManifold() is implemented for this class, but getHomologyH1() is not.

## Constructor & Destructor Documentation

regina::NBlockedSFSPair::~NBlockedSFSPair | ( |  | ) |

Destroys this structure and its constituent components.

## Member Function Documentation

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

NAbelianGroup * regina::NStandardTriangulation::getHomologyH1 | ( |  | ) | const

inline virtual inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented in regina::NLayeredSolidTorus, regina::NTriSolidTorus, regina::NLayeredChain, regina::NSpiralSolidTorus, regina::NLayeredTorusBundle, regina::NSnapPeaCensusTri, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NSnappedBall, regina::NTrivialTri, regina::NL31Pillow, and regina::NLayeredChainPair.

NManifold* regina::NBlockedSFSPair::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

std::string regina::NStandardTriangulation::getName | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

std::string regina::NStandardTriangulation::getTeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

static NBlockedSFSPair* regina::NBlockedSFSPair::isBlockedSFSPair | ( | NTriangulation * | tri | ) |

static

Determines if the given triangulation is a blocked pair of Seifert fibred spaces, as described by this class.

Parameters

  tri | the triangulation to examine.

Returns
  a newly created structure containing details of the blocked pair, or `null` if the given triangulation is not of this form.

static NStandardTriangulation* regina::NStandardTriangulation::isStandardTriangulation | ( | NComponent * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(NTriangulation*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

static NStandardTriangulation* regina::NStandardTriangulation::isStandardTriangulation | ( | NTriangulation * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(NComponent*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

const NMatrix2 & regina::NBlockedSFSPair::matchingReln | ( |  | ) | const

inline

Returns the matrix describing how the two saturated region boundaries are joined.

Note that if a layering is placed between the two region boundaries, then any changes to the boundary relationships caused by the layering are included in this matrix.

See the class notes above for precise information on how this matrix is presented.

Returns
  the matrix describing how the region boundaries are joined.

const NSatRegion & regina::NBlockedSFSPair::region | ( | int | which | ) | const

inline

Returns details of one of the two bounded saturated regions that form this triangulation.

See the class notes above for further information.

Parameters

  which | 0 if the first region should be returned, or 1 if the second region should be returned.

Returns
  details of the requested saturated region.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

std::ostream& regina::NBlockedSFSPair::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream& regina::NBlockedSFSPair::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NBlockedSFSPair::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

void regina::NStandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nblockedsfspair.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).